      REAL*8 A,B,F,G
      PARAMETER (A = 0.25D0)
      PARAMETER (B = 4.0D0)
      PARAMETER (F = 8.0D0)
      PARAMETER (G = 1.0D0)
      REAL*8 T,DT
      PARAMETER (DT=1.0D-3)
      PARAMETER (IX=10000000)
      REAL*8 X,Y,Z,XP,YP,ZP,DX,DY,DZ,XX,ZZ

      CALL INIT  (T,X,Y,Z)
      OPEN (10,FILE='poincare.dat',STATUS='UNKNOWN',
     +      FORM='FORMATTED')
        DO 11 I=1,IX
      CALL ODE (A,B,F,G,X,Y,Z,DX,DY,DZ)
      T = T + DT
      XP = X
      YP = Y
      ZP = Z
      CALL INTEG (DT,DX,X)
      CALL INTEG (DT,DY,Y)
      CALL INTEG (DT,DZ,Z)
      IF (    ((YP.LE.0.0D0).AND.(Y.GT.0.0D0))
     +    .OR.((YP.GE.0.0D0).AND.(Y.LT.0.0D0))) THEN
        XX = (Y*XP-YP*X)/(Y-YP)
        ZZ = (Y*ZP-YP*Z)/(Y-YP)
        WRITE(10,'(2(1X,F7.4))') XX,ZZ
      ENDIF
   11   CONTINUE
      CLOSE(10)
      STOP
      END

C ########################################

      SUBROUTINE INIT (T,X,Y,Z)
      REAL*8 T,X,Y,Z
      T = 0.0D0
      X = 1.0D0
      Y = 1.0D0
      Z = 0.0D0
      RETURN
      END

C ========================================

      SUBROUTINE ODE (A,B,F,G,X,Y,Z,DX,DY,DZ)
      REAL*8 A,B,F,G,X,Y,Z,DX,DY,DZ
      DX = - Y**2 - Z**2 - A*X + A*F
      DY = X*Y - B*X*Z - Y + G
      DZ = B*X*Y + X*Z - Z
      RETURN
      END

C ========================================

      SUBROUTINE INTEG (DT,DX,X)
      REAL*8 DT,X,DX
      X = X + DT * DX
      RETURN
      END
